////////////////////////////////////////////////////
// Aufgabe 5 Kapitel Prozeduren
// Farbgebung des Gingerbread-Man
// Parameter variieren
////////////////////////////////////////////////////
//cx und cy sind die interessanten Parameter, die 
//für das Aussehen der Map verantwortlich sind
float cx, cy;
int [] punktKoord = {0,0};
float[] punkt = {0.0,0.0};
float  xalt, yalt;
int w,h,n,i,f;
color farbe;
////////////////////////////////////////////////////
void setup() {
  w=900; h=900;
  surface.setSize(w,h);  
  background (255); //weißer Bildhintergrund
  farbe = color(0,0,0);
  xalt= 0.04; yalt= 0;//Startwerte
  cx = 1.8; cy = 1; //Wahl der Parameter
  //maximale Anzahl der Iterationschritte
  n= 5000000;//Testen Sie n = 200000, 500000000
  i =0; f=0;
}
////////////////////////////////////////////////
float[] iteration(float x, float y){
  float xalt = x; float yalt = y;
  punkt[0] = 1-yalt+cx*abs(xalt); 
  punkt[1] = cy*xalt;
  return punkt;
}
///////////////////////////////////////////////////
int[] koordinaten(float x, float y){
  //Bildausschnitt links unten (xu;yu), rechts oben (xo,yo)
  int xu = -700; int xo = 2000;
  int yu = -700; int yo = 2000;
  float xneu = x; float yneu = y;
   punktKoord[0] = round((xneu-xu)/(xo-xu)*w);
   punktKoord[1] = round((yo-yneu)/(yo-yu)*h);
   return punktKoord; 
}
//////////////////////////////////////////////////////////
color farbeWaehlen(int f){   
   if(f<=42)            {farbe = color(f+212,0,0);}  //rot-Bereich
   if(f> 42 && f< 84)   {farbe = color(f+171,f+171,0); }//gelb-Bereich
   if(f>=84 && f<= 126) {farbe = color(0,f+128,0); } //grün-Bereich
   if(f>=126 && f< 167) {farbe = color(0,f+88,f+88); } //türkis-Bereich
   if(f>=167 && f< 208) {farbe = color(0,0,f+45) ;} //blau-Bereich
   if(f>=208 && f< 256) {farbe = color(f,0,f); } //magenta-Bereich
   return farbe;   
}
//////////////////////////////////////////////////////////
void draw () {
  //m definiert, um bei i = 4000, 8000, 12000,..zu zeichnen
   int m=i+4000; //hier a=4000, d.h. immer nach 4000 Punkten wird gezeichnet
   if(m<=n){
     f= (f +1) % 256; //Farbewerte immer kleiner 256
     farbe = farbeWaehlen(f);
     stroke(farbe);
     while ((i<m) && (abs(xalt)<100000) &&  (abs(yalt)<100000)) {
      //stoppt wenn maximale Induktionstiefe erricht oder  bei Divergenz    
       punkt = iteration(xalt,yalt);
       xalt = punkt[0]; yalt = punkt[1];
       punktKoord = koordinaten(xalt,yalt);  
       point(punktKoord[0],punktKoord[1]);
       i++;
    }
  }
  //Speichern und stoppen, wenn eine der drei Bedingungen erfüllt ist  
   if ((i>=n) || (abs(xalt)>=100000) || (abs(yalt)>=100000) ){
     saveFrame("GingerBreadMan.jpg");
     noLoop();   
   }   
}